package forms.action;

import java.util.Date;
import javax.servlet.ServletContext;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import net.sourceforge.stripes.action.ActionBean;
import net.sourceforge.stripes.action.ActionBeanContext;
import net.sourceforge.stripes.action.DefaultHandler;
import net.sourceforge.stripes.action.ForwardResolution;
import net.sourceforge.stripes.action.Resolution;

import net.sourceforge.stripes.validation.BooleanTypeConverter;
import net.sourceforge.stripes.validation.DateTypeConverter;
import net.sourceforge.stripes.validation.EmailTypeConverter;
import net.sourceforge.stripes.validation.FloatTypeConverter;
import net.sourceforge.stripes.validation.IntegerTypeConverter;
import net.sourceforge.stripes.validation.LocalizableError;
import net.sourceforge.stripes.validation.Validate;
import net.sourceforge.stripes.validation.ValidationErrors;
import net.sourceforge.stripes.validation.ValidationMethod;

public class ProcessFormAction implements ActionBean {
    private Log log;
    private ActionBeanContext context;
    // form fields
    @Validate(required=true)
    private String name;
    @Validate(required=true, converter=DateTypeConverter.class)
    private Date date;
    @Validate(required=true, mask="[0-9]{4}-[0-9]{4}-[0-9]{4}-[0-9]{4}")
    private String visa;
    @Validate(required=true, converter=EmailTypeConverter.class)
    private String email;
    @Validate(required=true, converter=IntegerTypeConverter.class)
    private Integer number;
    @Validate(required=true, converter=BooleanTypeConverter.class)
    private Boolean bool;
    @Validate(required=true, converter=FloatTypeConverter.class)
    private Float pi;
    @Validate(mask="'?some text'?")
    private String optional;

    public ProcessFormAction() {
        this.log = LogFactory.getLog(this.getClass());
    }

    public ActionBeanContext getContext() { return context; }
    public void setContext(ActionBeanContext context) { this.context = context; }

    public String getName() { return this.name; }
    public void setName(String name) { this.name = name; }

    public Date getDate() { return this.date; }
    public void setDate(Date date) { this.date = date; }

    public String getVisa() { return this.visa; }
    public void setVisa(String visa) { this.visa = visa; }

    public String getEmail() { return this.email; }
    public void setEmail(String email) { this.email = email; }

    public Integer getNumber() { return this.number; }
    public void setNumber(Integer number) { this.number = number; }

    public Boolean getBool() { return this.bool; }
    public void setBool(Boolean bool) { this.bool = bool; }

    public Float getPi() { return this.pi; }
    public void setPi(Float pi) { this.pi = pi; }

    public String getOptional() { return this.optional; }
    public void setOptional(String optional) { this.optional = optional; }

//     @DefaultHandler
//     public Resolution thisMethodRunsIfNoOtherMethodMatchesTheSubmission() {
//     }

    public Resolution process() {
	log.debug("The form processor got the following:");
	log.debug("name: " + this.name);
	log.debug("date: " + this.date);
	log.debug("visa: " + this.visa);
	log.debug("email: " + this.email);
	log.debug("number: " + this.number);
	log.debug("bool: " + this.bool);
	log.debug("pi: " + this.pi);
	return new ForwardResolution("/default.jsp");
    }

    @ValidationMethod()
    public void validatePiValue(ValidationErrors errors) {
	// required is alreay checked
	if (!new Float(3.14).equals(getPi())) {
	    errors.add("pi", new LocalizableError("error.pi.digits"));
	}
    }

}
